'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Scoped = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styleTags = {};
var counter = 0;

var Scoped = exports.Scoped = function (_React$Component) {
  _inherits(Scoped, _React$Component);

  function Scoped(props) {
    _classCallCheck(this, Scoped);

    var _this = _possibleConstructorReturn(this, (Scoped.__proto__ || Object.getPrototypeOf(Scoped)).call(this, props));

    if (typeof props.css === 'string') {
      if (props.css.indexOf('&') <= 0) {
        console.warn('Kremling\'s <Scoped css="..."> css prop should have the \'&\' character in it to scope the css classes');
      }
      var existingDomEl = styleTags[props.css];
      if (existingDomEl) {
        _this.styleRef = existingDomEl;
        existingDomEl.kremlings++;
        _this.kremlingAttrName = _this.styleRef.kremlingAttr;
        _this.kremlingAttrValue = _this.styleRef.kremlingValue;
      } else {
        // The attribute for namespacing the css
        _this.kremlingAttrName = 'data-' + (props.namespace || Scoped.defaultNamespace);
        _this.kremlingAttrValue = counter++;

        // The css to append to the dom
        var kremlingSelector = '[' + _this.kremlingAttrName + '="' + _this.kremlingAttrValue + '"]';
        var transformedCSS = props.css.replace(/& (.+){/g, function (match, cssRule) {
          cssRule = cssRule.trim();
          return kremlingSelector + ' ' + cssRule + ', ' + kremlingSelector + cssRule + ' {';
        });

        // The dom element
        var el = document.createElement('style');
        el.setAttribute('type', 'text/css');
        el.textContent = transformedCSS;
        el.kremlings = 1;
        el.kremlingAttr = kremlingSelector;
        el.kremlingValue = _this.kremlingAttrValue;
        document.head.appendChild(el);
        styleTags[props.css] = el;
        _this.styleRef = el;
      }
    }
    return _this;
  }

  _createClass(Scoped, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.Children.map(this.props.children, function (child) {
        if (_react2.default.isValidElement(child)) {
          return _react2.default.cloneElement(child, _defineProperty({}, _this2.kremlingAttrName, _this2.kremlingAttrValue));
        } else {
          return child;
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (--this.styleRef.kremlings === 0) {
        this.styleRef.parentNode.removeChild(this.styleRef);
        delete styleTags[this.props.css];
      }
    }
  }]);

  return Scoped;
}(_react2.default.Component);

Scoped.propTypes = {
  css: _propTypes2.default.string.isRequired,
  namespace: _propTypes2.default.string
};
Scoped.defaultNamespace = 'kremling';
//# sourceMappingURL=scoped.component.js.map